package org.act.od.impl.view.toolMenuBar {
import flash.events.MouseEvent;

import mx.containers.ControlBar;
import mx.containers.HBox;
import mx.controls.LinkButton;
import mx.controls.VRule;

import org.act.od.impl.other.Localizator;
import org.act.od.impl.viewhelper.DesignerToolBarVH;

/**
 * Tool Bar for OrDesigner.
 */
public class DesignerToolBar extends ControlBar {
  /**
   * The source for "newproject" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/newproject.gif")]
  public static const newproject:Class;

  /**
   * The source for "newfile" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/process.gif")]
  public static const newprocess:Class;

  /**
   * The source for "save" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/save.gif")]
  public static const save:Class;

  /**
   * The source for "saveall" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/saveall.gif")]
  public static const saveall:Class;

  /**
   * The source for "save" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/save_gray.gif")]
  public static const save_gray:Class;

  /**
   * The source for "saveall" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/saveall_gray.gif")]
  public static const saveall_gray:Class;


  /**
   * The source for "undo" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/undo.svg")]
  public static const undo:Class;

  /**
   * The source for "redo" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/redo.svg")]
  public static const redo:Class;

  /**
   * The source for "export" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/export.svg")]
  public static const export:Class;

  /**
   * The source for "deploy" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/deploy.png")]
  public static const deploy:Class;

  /**
   * The source for "zoomin" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/zoomin.gif")]
  public static const zoomin:Class;

  /**
   * The source for "zoomout" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/zoomout.gif")]
  public static const zoomout:Class;

  /**
   * The source for "cut" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/cut.gif")]
  public static const cut:Class;

  /**
   * The source for "copy" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/copy.gif")]
  public static const copy:Class;

  /**
   * The source for "paste" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/paste.gif")]
  public static const paste:Class;

  /**
   * The source for "processConfig" image data binding.
   */
  [Embed(source="/../assets/icon/toolbar/right-access.png")]
  public static const processConfig:Class;

  private var newProjectButton:LinkButton = new LinkButton();
  private var newProcessButton:LinkButton = new LinkButton();
  private var saveButton:LinkButton = new LinkButton();
  private var exportButton:LinkButton = new LinkButton();
  private var deployButton:LinkButton = new LinkButton();
  private var saveAllButton:LinkButton = new LinkButton();
  private var zoomInButton:LinkButton = new LinkButton();
  private var zoomOutButton:LinkButton = new LinkButton();
  private var cutButton:LinkButton = new LinkButton();
  private var copyButton:LinkButton = new LinkButton();
  private var pasteButton:LinkButton = new LinkButton();
  private var undoButton:LinkButton = new LinkButton();
  private var redoButton:LinkButton = new LinkButton();
  private var processAccessConfigButton:LinkButton = new LinkButton();

  private var designerToolBarVH:DesignerToolBarVH;
  private var localizator:Localizator;

  /**
   * Initialize DesignerToolBar.
   */
  public function DesignerToolBar() {
    super();
    this.designerToolBarVH = new DesignerToolBarVH(this, "DesignerToolBarVH");
    this.localizator = Localizator.getInstance();
    this.percentHeight = 2;
    this.percentWidth = 100;

    newProjectButton.setStyle("icon", newproject);
    newProjectButton.percentHeight = 100;
    newProjectButton.width = 20;
    newProjectButton.toolTip = localizator.getText('toolbar.newproject');

    newProcessButton.setStyle("icon", newprocess);
    newProcessButton.percentHeight = 100;
    newProcessButton.width = 20;
    newProcessButton.toolTip = localizator.getText('toolbar.newprocess');

    saveButton.setStyle("icon", save);
    saveButton.percentHeight = 100;
    saveButton.width = 20;
    saveButton.toolTip = localizator.getText('toolbar.save');
    saveButton.automationName = "toolBarSave";

    exportButton.setStyle("icon", export);
    exportButton.percentHeight = 100;
    exportButton.width = 20;
    exportButton.toolTip = localizator.getText('toolbar.export');
    exportButton.automationName = "toolBarExport";

    deployButton.setStyle("icon", deploy);
    deployButton.percentHeight = 100;
    deployButton.width = 20;
    deployButton.toolTip = localizator.getText('toolbar.deploy');
    deployButton.automationName = "toolBarDeploy";

    saveAllButton.setStyle("icon", saveall);
    saveAllButton.percentHeight = 100;
    saveAllButton.width = 20;
    saveAllButton.toolTip = localizator.getText('toolbar.saveall');

    zoomInButton.setStyle("icon", zoomin);
    zoomInButton.width = 20;
    zoomInButton.percentHeight = 100;
    zoomInButton.toolTip = localizator.getText('toolbar.zoomin');

    zoomOutButton.setStyle("icon", zoomout);
    zoomOutButton.width = 20;
    zoomOutButton.percentHeight = 100;
    zoomOutButton.toolTip = localizator.getText('toolbar.zoomout');

    cutButton.setStyle("icon", cut);
    cutButton.width = 20;
    cutButton.percentHeight = 100;
    cutButton.toolTip = localizator.getText('toolbar.cut');

    copyButton.setStyle("icon", copy);
    copyButton.width = 20;
    copyButton.percentHeight = 100;
    copyButton.toolTip = localizator.getText('toolbar.copy');

    pasteButton.setStyle("icon", paste);
    pasteButton.width = 20;
    pasteButton.percentHeight = 100;
    pasteButton.toolTip = localizator.getText('toolbar.paste');

    undoButton.setStyle("icon", undo);
    undoButton.width = 20;
    undoButton.percentHeight = 100;
    undoButton.toolTip = localizator.getText('toolbar.undo');

    redoButton.setStyle("icon", redo);
    redoButton.width = 20;
    redoButton.percentHeight = 100;
    redoButton.toolTip = localizator.getText('toolbar.redo');

    processAccessConfigButton.setStyle("icon", processConfig);
    processAccessConfigButton.width = 20;
    processAccessConfigButton.percentHeight = 100;
    processAccessConfigButton.toolTip = localizator.getText('toolbar.access');
    processAccessConfigButton.automationName = "processConfig";

    //layout
    var newBox:HBox = new HBox();
    newBox.percentHeight = 100;
    newBox.width = 50;
    newBox.addChild(newProjectButton);
    newBox.addChild(newProcessButton);

    var saveBox:HBox = new HBox();
    saveBox.percentHeight = 100;
    saveBox.width = 110;
    saveBox.addChild(saveButton);
    saveBox.addChild(saveAllButton);
    saveBox.addChild(exportButton);
    saveBox.addChild(deployButton);

    var zoomBox:HBox = new HBox();
    zoomBox.percentHeight = 100;
    zoomBox.width = 50;
    zoomBox.addChild(zoomInButton);
    zoomBox.addChild(zoomOutButton);

    var undoRedoBox:HBox = new HBox();
    undoRedoBox.percentHeight = 100;
    undoRedoBox.width = 50;
    undoRedoBox.addChild(undoButton);
    undoRedoBox.addChild(redoButton);

    var editBox:HBox = new HBox();
    editBox.percentHeight = 100;
    editBox.width = 80;
    editBox.addChild(cutButton);
    editBox.addChild(copyButton);
    editBox.addChild(pasteButton);

    var processConfigBox:HBox = new HBox();
    processConfigBox.percentHeight = 100;
    processConfigBox.width = 25;
    processConfigBox.addChild(processAccessConfigButton);

    var vrule1:VRule = new VRule();
    vrule1.percentHeight = 100;

    var vrule2:VRule = new VRule();
    vrule2.percentHeight = 100;

    var vrule3:VRule = new VRule();
    vrule3.percentHeight = 100;

    var vrule4:VRule = new VRule();
    vrule4.percentHeight = 100;

    var vrule5:VRule = new VRule();
    vrule5.percentHeight = 100;

    var vrule6:VRule = new VRule();
    vrule6.percentHeight = 100;


    this.setStyle("borderStyle", "solid");

    this.addChild(newBox);
    this.addChild(vrule1);
    this.addChild(saveBox);
    this.addChild(vrule2);
    this.addChild(editBox);
    this.addChild(vrule3);
    this.addChild(zoomBox);
    this.addChild(vrule4);
    this.addChild(undoRedoBox);
    this.addChild(vrule5);
    this.addChild(processConfigBox);
    this.addChild(vrule6);

    this.initEventListener();
  }

  /**
   * Initialize the listeners of all button.
   */
  private function initEventListener():void {
    this.newProjectButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.newProjectHandler);
    this.newProcessButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.newFileHandler);

    this.saveButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onSaveHandler);
    this.saveAllButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onSaveAllHandler);
    this.exportButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onExportHandler);
    this.deployButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onDeployHandler);

    this.copyButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onCopyHandler);
    this.pasteButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onPasteHandler);
    this.cutButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onCutHandler);

    this.zoomInButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onZoomInHandler);
    this.zoomOutButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onZoomOutHandler);

    this.undoButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onUndo);
    this.redoButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onRedo);

    this.processAccessConfigButton.addEventListener(MouseEvent.CLICK, designerToolBarVH.onProcessAccessConfigHandler);
  }


  /**
   * enabled the button save
   * @param value
   */
  public function enabledSave(value:Boolean):void {
    if (!value) {
      saveButton.setStyle("icon", save_gray);
    } else {
      saveButton.setStyle("icon", save);
    }
    this.saveButton.enabled = value;
  }

  /**
   *  enabled the button saveAll
   * @param value
   */
  public function enabledSaveAll(value:Boolean):void {
    if (!value) {
      saveAllButton.setStyle("icon", saveall_gray);
    } else {
      saveAllButton.setStyle("icon", saveall);
    }
    this.saveAllButton.enabled = value;
  }
}
}

