/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.commands {
  import com.adobe.cairngorm.commands.ICommand;
  import com.adobe.cairngorm.control.CairngormEvent;

  import org.ow2.orchestra.designer.bpmn.model.AbstractElementWithPosition;
  import org.ow2.orchestra.designer.events.ProcessModificationEvent;

  public class AddProcessElementWithSequenceFlowCMD implements ICommand {
    public function AddProcessElementWithSequenceFlowCMD() {
    }

    public function execute(event:CairngormEvent):void {
      if (event != null && event is ProcessModificationEvent) {
        var processEvt:ProcessModificationEvent = event as ProcessModificationEvent;
        // save process model
        processEvt.processEditorModel.saveModelForUndo();

        if (processEvt.type == ProcessModificationEvent.PROCESS_ELEMENT_ADD_WITH_SEQUENCE && processEvt.processEditorModel != null) {
          // create new element
          var newModel:AbstractElementWithPosition = AddProcessElementCMD.addNewElementToModel(
                  processEvt.element_pos_x,
                  processEvt.element_pos_y,
                  processEvt.modelElement,
                  processEvt.processEditorModel.processModel);
          // create sequecneFlow to this new element
          CreateSequenceFlowCMD.createSequenceFlow(processEvt.sourceElement, newModel, processEvt.processEditorModel.processModel);
          // selected newly added element
          processEvt.processEditorModel.selectedElements.removeAll();
          processEvt.processEditorModel.selectedElements.addItem(newModel);
        }
      }
    }
  }
}
