/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
import com.adobe.cairngorm.control.CairngormEvent;

import org.ow2.orchestra.designer.vo.FileNavigatorItem;

public class FileNavigatorEvent extends CairngormEvent {

  /**
   * Get the list of projects and processes from the server.
   */
  public static const FETCH_MODEL:String = "FileNavigatorEvent_FetchModel";
  /**
   * Open a process file.
   */
  public static const PROCESS_OPEN:String = "FileNavigatorEvent_ProcessOpen";
  /**
   * Delete a process file.
   */
  public static const ITEM_DELETE:String = "FileNavigatorEvent_ItemDelete";

  /**
   * Create a process file.
   */
  public static const PROCESS_CREATE:String = "FileNavigatorEvent_ProcessCreate";

  /**
   * Create a project file.
   */
  public static const PROJECT_CREATE:String = "FileNavigatorEvent_ProjectCreate";

  private var _item:FileNavigatorItem;

  public function FileNavigatorEvent(type:String, navigatorItem:FileNavigatorItem = null, bubbles:Boolean = false, cancelable:Boolean = false) {
    super(type, bubbles, cancelable);
    _item = navigatorItem;
  }

  public function get item():FileNavigatorItem {
    return _item;
  }


}
}
