/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.model {
import mx.collections.ArrayCollection;

import org.ow2.orchestra.designer.vo.FileNavigatorProcess;

/**
 * @author diouf-a
 */
[Bindable]
public class AccessProcessSettingsModel {

  /**
   * A list of {@link org.ow2.orchestra.designer.vo.FileNavigatorUserAccessPermissions}
   */
  private var _lAccess:ArrayCollection = new ArrayCollection();

  private var _selectedProcess:FileNavigatorProcess = null;

  /**
   * List of processes on which the current user have admin permissions.
   */
  private var _processesWithAdminPermission:ArrayCollection = new ArrayCollection();

  public function AccessProcessSettingsModel() {
  }

  /**
   * A list of {@link org.ow2.orchestra.designer.vo.FileNavigatorUserAccessPermissions} for a given selected process.
   * {@see AccessProcessSettingsModel#selectedProcess}
   */
  public function get lAccess():ArrayCollection {
    return _lAccess;
  }


  /**
   * The process on which {@link org.ow2.orchestra.designer.vo.FileNavigatorUserAccessPermissions}
   * contained into {@see AccessProcessSettingsModel#lAccess} applies
   */
  public function get selectedProcess():FileNavigatorProcess {
    return _selectedProcess;
  }

  public function set selectedProcess(process:FileNavigatorProcess):void {
    _selectedProcess = process;
  }

  public function get processesWithAdminPermission():ArrayCollection {
    return _processesWithAdminPermission;
  }

}
}
