/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.utils {
  import mx.utils.ObjectUtil;

  /**
   * Utility class.
   *
   * @author albertil
   *
   */
  public class DesignerUtil {
    /**
     * <p>Perform a deep (recursive) copy of an object using
     * <code>mx.utils.ObjectUtil.copy()</code>.</p>
     * <p>This method auto-register the class alias of the given object using
     * <code>flash.net.registerClassAlias()</code>.</p>
     *
     * <p>Should be use with caution!</p>
     *
     * @param value the object to copy.
     * @return the new copy the original object
     *
     * @see mx.utils.ObjectUtil
     * @see flash.net.registerClassAlias
     */
    public static function copy(value:Object):Object {
      if (value == null) {
        return null;
      }
//			var className:String=getQualifiedClassName(value);
      // Sometimes package names and class name are separated by "::" this should be replaced
      //by a dot "." unless Granite complains
//			var pattern:RegExp=/::/g;
//			className=className.replace(pattern, ".");
//			registerClassAlias(className, getDefinitionByName(className) as Class);
      return ObjectUtil.copy(value);
    }

  }
}
