/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.view.menuBar
{


  public class MenuBarItem
  {

    private var _enabled:Boolean;
    private var _groupName:String;
    private var _icon:Class;
    private var _label:String;
    private var _toggled:Boolean;
    // normal, separator, check, or radio
    private var _type:String;
    private var _handler:Function;


    public function MenuBarItem(label:String, enabled:Boolean = true, handler:Function = null, groupName:String = null, icon:Class = null, toggled:Boolean = false, type:String = "normal") {
      this.label = label;
      this.enabled = enabled;
      this.groupName = groupName;
      this.icon = icon;
      this.toggled = toggled;
      this.type = type;
      this._handler = handler;
    }


    public function get enabled():Boolean
    {
      return _enabled;
    }

    public function set enabled(value:Boolean):void
    {
      _enabled = value;
    }

    public function get groupName():String
    {
      return _groupName;
    }

    public function set groupName(value:String):void
    {
      _groupName = value;
    }

    public function get icon():Class
    {
      return _icon;
    }

    public function set icon(value:Class):void
    {
      _icon = value;
    }

    public function get label():String
    {
      return _label;
    }

    public function set label(value:String):void
    {
      _label = value;
    }

    public function get toggled():Boolean
    {
      return _toggled;
    }

    public function set toggled(value:Boolean):void
    {
      _toggled = value;
    }

    public function get type():String
    {
      return _type;
    }

    public function set type(value:String):void
    {
      _type = value;
    }

    public function get handler():Function {
      return _handler;
    }
  }
}